import React, { useState } from "react";
import logo from "./logo.svg";
import "./App.css";

interface GreeterProps {
  name: string;
  setName: (name: string) => void;
}

const Greeter: React.FC<GreeterProps> = ({ name, setName }) => {
  return (
    <div>
      {name.length ? <>Hello </> : <>What is your name? </>}
      <input
        autoComplete="false"
        className="border-b focus:border-blue-400 border-gray-50 focus:outline-none text-center bg-transparent"
        autoFocus
        type="text"
        style={{
          width: Math.max(100, 14 * name.length) + "px",
        }}
        value={name}
        onChange={(e) => setName(e.target.value)}
      />
    </div>
  );
};

function App() {
  const [count, setCount] = useState(0);
  const [name, setName] = useState("");
  return (
    <div className="App">
      <header className="App-header">
        <img
          src={logo}
          className="App-logo"
          alt="logo"
          style={{
            animationDuration: `${20 / (name.length || 1)}s`,
          }}
        />
        <p>Hello Vite + React!</p>
        <p>
          <button
            className="bg-blue-400 bg-opacity-60 hover:bg-blue-600 p-2 rounded m-2"
            type="button"
            onClick={() => setCount((count) => count + 1)}
          >
            count is: {count}
          </button>
        </p>
        <Greeter name={name} setName={setName} />
      </header>
    </div>
  );
}

export default App;
